#!/usr/bin/env python

import os, re

def collect_elements(filename):
    list_elements_fn = []
    f = open(filename)
    lines = list(f)
    f.close()
    for line in lines:
        line = re.sub("^ +", "", line)
        line = re.sub(" +", "\t", line)
        eles = line.split("\t")
        if line.startswith("PrDM"):
            continue
        PrDM = eles[0]
        T090C = eles[1]
        Sal00 = eles[7]
        list_elements_fn.append([PrDM, T090C, Sal00])
    return list_elements_fn

def sixty2ten(sixty):
    #print("sixty", sixty)
    elesTMP = re.sub("[A-Z]$", "", sixty)
    eles = elesTMP.split(" ")
    seisu = eles[0]
    shosu = eles[1]
    ten = int(seisu) + float(shosu)/60
    return(round(ten, 5))


def make_each_station_lines(stationR, list_elements_fn):
    lines_fn = []
    #print("stationR", stationR)
    #print("list_elements_fn", list_elements_fn)
    for eles in list_elements_fn:
        #print("stationR", stationR)
        station = re.sub("-R", "", stationR)
        #print("station", station)
        line = re.sub("\d+$", "", station)
        line = re.sub("1b$", "", line)
        PrDM = eles[0]
        T090C = eles[1]
        Sal00 = eles[2]
        eles_latlon = dic_station_latlon[station]
        #print("eles_latlon", eles_latlon)
        lat = sixty2ten(eles_latlon[0])
        lon = sixty2ten(eles_latlon[1])
        line = line + "\t" + station + "\t" + str(lat) + "\t" + str(lon) + "\t" + PrDM + "\t" + T090C + "\t" + Sal00
        lines_fn.append(line)
    return lines_fn

def make_lines():
    lines_fn = []
    for station in stations:
        filename = dir_name_CTDdata + "/" + station + "/report/d" + station + extension_CTDdata_file
        #print("filename", filename)
        list_elements = collect_elements(filename)
        lines_each_station = make_each_station_lines(station, list_elements)
        lines_fn = lines_fn + lines_each_station
        #print("lines_fn", lines_fn)
    return lines_fn

def print_lines():
    out = open(outfile, "w")
    out.write(firstline + "\n")
    for line in lines:
        out.write(line + "\n")
    out.close()

def get_latlon():
    f = open(file_latlon_csv)
    lines_latlong = list(f)
    f.close()
    
    dic_station_latlon = {}
    for station in stations:
        hit_line = ""
        stationTMP = re.sub("-R", "", station)
        #print("stationTMP", stationTMP)
        lat = ""
        lon = ""
        for line in lines_latlong:
            line = line.rstrip("\n")
            if stationTMP + "," in line and "CTD-CMS STARTED" in line:
                hit_line = line
                ele = line.split(",")
                lat = ele[4]
                lon = ele[5]
                break
        dic_station_latlon[stationTMP] = [lat, lon]
    
    return dic_station_latlon

#### main program

dirsTMP = os.listdir(".")
dir_name_CTDdata = "KT1-1_CTDdata"
extension_CTDdata_file = ".asc" 

stations = ["AA1-R",
            "AA2-R",
            "AA3-R",
            "AA4-R",
            "AA5-R",
            "AA6-R",
            ]
#firstline = "line	station	lat	lon	depth	temp	sal	水深"
firstline = "line	station	lat	lon	depth	temp	sal"

outfile = "out_CTDdata.txt"

file_latlon_csv = "KT1-1.csv"

dic_station_latlon = get_latlon()
#for name, value in dic_station_latlon.items():
#    print(name)
#    print(value)

lines = make_lines()
print_lines()

